"variations":
{
	"noMSAA":
	{
		"default": true
	},
	"MSAA":
	{
		
	}
}
#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
struct shader_input_0
{
	float2 texcoord : TEXCOORD0;
};

// outputs
struct shader_output_0
{
	float4 colour : COLOUR0;
};

// uniforms
noMSAA:
{
	layout(binding = 0) uniform sampler2D gbuffer_0;
	layout(binding = 1) uniform sampler2D gbuffer_1;
	layout(binding = 2) uniform sampler2D depth_buffer;
}

MSAA:
{
	layout(binding = 0) uniform sampler2DMS gbuffer_0;
	layout(binding = 1) uniform sampler2DMS gbuffer_1;
	layout(binding = 2) uniform sampler2DMS depth_buffer;
}

layout(binding = 0) uniform GenericViewUniforms
{
	vec4 dims;
} view;

layout(binding = 3) uniform LightData
{
	mat4 worldMatrix;
	mat4 viewMatrix;
	mat4 projectionMatrix;
	vec4 diffuse;
	vec4 user;
	
} light;

void main()
{
	MSAA:
	{
		ivec2 texelCoord = ivec2(view.dims.xy * shader_input_0.texcoord);
		vec4 diffuse = texelFetch(gbuffer_1, texelCoord, gl_SampleID);
	}
	
	noMSAA:
	{
		vec4 diffuse = texture(gbuffer_1, shader_input_0.texcoord);
	}
	
	if(diffuse.a < 1.0)
	{
		discard;
	}
	
	vec4 colour = vec4(0.0, 0.0, 0.0, 1.0);
	colour.xyz = light.diffuse.xyz * diffuse.xyz;
	
	shader_output_0.colour = colour;
}
