"variations":
{
	"forward":
	{
		"default": true
	},
	"gbuffer":
	{
		"blend_state":
		{
			"enabled": false
		}
	},
	"shadow_map":
	{
	}
}

#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
gbuffer:
{
	struct shader_input_0
	{
		float3 world_pos : POSITION1;
		float2 texcoord : TEXCOORD0;
		float3 normal : NORMAL0;
	};
}

// outputs
forward:
{
	struct shader_output_0
	{
		float4 colour : COLOUR0;
	};
}

gbuffer:
{
	struct shader_output_0
	{
		float4 normal : COLOUR0;
		float4 diffuse : COLOUR1;
		float4 specular : COLOUR2;
	};
}

layout(binding = 3) uniform EntityData
{
	mat4 world;
	vec4 user;
} entity;


void main()
{
	vec4 colour =  entity.user;
	
	forward:
	{
		shader_output_0.colour = colour;
	}
	
	gbuffer:
	{
		shader_output_0.diffuse = colour;
		shader_output_0.normal = vec4(shader_input_0.normal, 1.0);
		shader_output_0.specular = vec4(0.0);
	}
}
