#version 450
#extension GL_ARB_separate_shader_objects : enable

struct shader_input_0
{
	float4 position : POSITION0;
	float2 texcoord : TEXCOORD0;
};

struct shader_output_0
{
	float4 position : POSITION0;
	float3 worldPosition : POSITION1;
	float2 texcoord : TEXCOORD0;
	float3 normal : NORMAL0;
};

layout(binding = 2) uniform ProjectionMatrix
{
	mat4 proj;
} proj;

layout(binding = 3) uniform EntityData
{
	mat4 world;
	vec4 user_data0;
} entity;

void main()
{
	shader_output_0.texcoord = shader_input_0.texcoord;	
    vec4 worldPos = entity.world * shader_input_0.position;
    shader_output_0.worldPosition = worldPos.xyz;
	shader_output_0.position = proj.proj * worldPos;
}