"variations":
{
	"default":
	{
		"skip": true,
		"default": true
	},
	"shadow_map_point":
	{
		"input_primitive": "triangles",
		"output_primitive": "triangles",
		"max_vertices": 18
	}
}

#version 450
#extension GL_ARB_separate_shader_objects : enable

struct shader_input_0
{
	float3 worldPosition : POSITION1;
	float2 texcoord : TEXCOORD0;
	float3 normal : NORMAL0;
};

struct shader_output_0
{
	float4 position : POSITION0;
	float3 worldPosition : POSITION1;
	float2 texcoord : TEXCOORD0;
	float3 normal : NORMAL0;
};

layout(binding = 2) uniform ProjectionMatrices
{
	mat4 proj[6];
} proj;

void main()
{
	for(int i = 0; i < 6; ++i)
	{
		mat4 m = proj.proj[i];
		
		vec4 pos0 = m * vec4(shader_input_0.worldPosition[0], 1.0);
		vec4 pos1 = m * vec4(shader_input_0.worldPosition[1], 1.0);
		vec4 pos2 = m * vec4(shader_input_0.worldPosition[2], 1.0);
		
		gl_Layer = i;
		shader_output_0.position = pos0;
		shader_output_0.worldPosition = shader_input_0.worldPosition[0];
		shader_output_0.texcoord = shader_input_0.texcoord[0];
		shader_output_0.normal = shader_input_0.normal[0];
		EmitVertex();
		
		gl_Layer = i;
		shader_output_0.position = pos1;
		shader_output_0.worldPosition = shader_input_0.worldPosition[1];
		shader_output_0.texcoord = shader_input_0.texcoord[1];
		shader_output_0.normal = shader_input_0.normal[1];
		EmitVertex();
		
		gl_Layer = i;
		shader_output_0.position = pos2;
		shader_output_0.worldPosition = shader_input_0.worldPosition[2];
		shader_output_0.texcoord = shader_input_0.texcoord[2];
		shader_output_0.normal = shader_input_0.normal[2];
		EmitVertex();
		
		EndPrimitive();		
	}
}