#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
struct shader_input_0
{
	float2 texcoord : TEXCOORD0;
};

// outputs
struct shader_output_0
{
	float4 colour : COLOUR0;
};

// uniforms
layout(binding = 0) uniform sampler2D src;

layout(binding = 3) uniform EntityData
{
	mat4 world;
	vec4 user_data0;
} entity;

void main()
{
	float alpha = texture(src, shader_input_0.texcoord).r;
	if(entity.user_data0.w > 0.0 && alpha < entity.user_data0.w)
	{
		discard;
	}
	shader_output_0.colour = vec4(entity.user_data0.xyz, alpha);
}
