"variations":
{
	"forward":
	{
		"default": true
	},
	"gbuffer":
	{
		
	},
	"shadow_map":
	{
	
	}
}

#version 450
#extension GL_ARB_separate_shader_objects : enable

// inputs
forward/shadow_map:
{
	struct shader_input_0
	{
		float2 texcoord : TEXCOORD0;
	};
}

gbuffer:
{
	struct shader_input_0
	{
		float3 world_pos : POSITION1;
		float2 texcoord : TEXCOORD0;
		float3 normal : NORMAL0;
	};
}

// outputs
forward:
{
	struct shader_output_0
	{
		float4 colour : COLOUR0;
	};
}

gbuffer:
{
	struct shader_output_0
	{
		float4 normal : COLOUR0;
		float4 diffuse : COLOUR1;
		float4 specular : COLOUR2;
	};
}


// uniforms
layout(binding = 0) uniform sampler2D src;


void main()
{
	vec4 colour = texture(src, shader_input_0.texcoord);
	
	forward:
	{
		shader_output_0.colour = colour;
	}
	
	gbuffer:
	{
		shader_output_0.diffuse = colour;
		shader_output_0.normal = vec4(shader_input_0.normal, 1.0);
		shader_output_0.specular = vec4(0.0);
	}
}