namespace engine
{
    namespace e_cmp
    {
        enum cmp : u64
        {
            none = 0,
            transform = 1 << 0,
            renderable = 1 << 1,
            camera = 1 << 2,
            light = 1 << 3,
            ui = 1 << 4,
            textureRef = 1 << 5,
            modelRef = 1 << 6,
            soundRef = 1 << 7,
            fontRef = 1 << 8,
            text = 1 << 9,
            triggers = 1 << 10
        };
    }

    namespace e_baseEntityFlags
    {
        enum baseEntityFlags : u64
        {
            none = 0,
            allocated = 1 << 0,
            disabled = 1 << 1,
        };
    }

    namespace e_entityFlags
    {
        enum entityFlags : u64
        {
            hidden = 1 << 2,
            hovered = 1 << 3,
            selected = 1 << 4,
            wasHovered = 1 << 5,
            wasSelected = 1 << 6,
            recreateText = 1 << 7,
            passthroughCursor = 1 << 8
        };
    }

    namespace e_cameraType
    {
        enum cameraType
        {
            orthographic,
            perspective
        };
    }
    typedef e_cameraType::cameraType CameraType;


    namespace e_lightType
    {
        enum lightType
        {
            directional,
            point,
            spot
        };
    }
    typedef e_lightType::lightType LightType;

}