#pragma once

#include "app.h"
#include "engine.h"
#include "dev_ui.h"

namespace engine
{
    class EngineApp : public App
    {
    public:
        Engine* m_engine = nullptr;
        bool    m_devUIOpen = false;
        bool    m_fullscreen = false;

        virtual void setup() override;
        virtual void shutdown() override;
        virtual void processInput(std::vector<utils::InputEvent>& events);
        virtual void update() override;
        virtual void render() override;
        virtual void resize(u32 width, u32 height) override;
    };
}
