#pragma once

#include "logic.h"
#include "defs.h"


namespace engine
{
	namespace e_saveState
	{
		enum saveState
		{
			waiting,
			saving,
			loading,
			saved,
			loaded
		};
	}
	typedef  e_saveState::saveState SaveState;

	class SaveManager
	{
	public:
		virtual void setup();
		virtual void update(float dt) { m_internal->update(dt); }
		virtual void shutdown() { m_internal->shutdown(); }

		virtual void setSaveLocation(const std::string& location) { m_internal->setSaveLocation(location); }
		virtual void save(const GameState& j) { m_internal->save(j); }
		virtual void load(GameState& j) { m_internal->load(j); }

		virtual SaveState getSaveState() { return m_internal->getSaveState(); }

		static SaveManager* get();

	protected:
		SaveManager* m_internal = nullptr;
	};
}